SystemOrganization addCategory: #TusLibros!

TestCase subclass: #TusLibrosTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 17:11'!
carrito

	^ Cart newCartWithId: '007'! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 20:44'!
test01AllCartsAreCreatedEmpty
	"Todo carrito se crea vaco"

	self assert: self carrito isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 21:45'!
test02AfterAddingTheFirstBookCartShouldNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	self deny: (self carrito addISBN: '6464564564564' withQuantity: 1) isEmpty.! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 16:54'!
test03AfterAddingMoreBooksCartShouldStillNotBeEmpty
	"Luego de agregarle libros, el carrito no est vaco"

	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carrito addISBN: aBook withQuantity: 1.
	
	self deny: (aCartWithBooks addISBN: aBook withQuantity: 1) isEmpty.
	! !

!TusLibrosTest methodsFor: 'as yet unclassified' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 17:21'!
test03CartShouldListBooksAdded
	
	| aBook aCartWithBooks|
	
	aBook:= '35145645646748'.
	
	aCartWithBooks:=  self carrito addISBN: aBook withQuantity: 1.
	aCartWithBooks addISBN: '6464564564564' withQuantity: 1.
	! !

Object subclass: #Cart
	instanceVariableNames: 'id items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TusLibros'!

!Cart class methodsFor: 'instance-creation' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 17:11'!
newCartWithId: anId
	
	^self new emptyCartWithId: anId  
	! !

!Cart methodsFor: 'adding' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 16:29'!
addISBN: anISBN withQuantity: aQuantity 
	
	items add: anISBN withOccurrences: aQuantity ! !

!Cart methodsFor: 'Initializing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 16:51'!
emptyCartWithId: anId
	
	id := anId.
	items := Bag new.! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/27/2013 21:46'!
isEmpty

	^items isEmpty! !

!Cart methodsFor: 'testing' stamp: 'EmilianoMenendezEzequielNicols 5/29/2013 16:39'!
listItems

	^items valuesAndCounts! !
